#include <unistd.h>
#include <stdio.h>
#include <sys/mman.h>
#include <stdlib.h>
#include <string.h>

typedef struct _blacklist {
  char *banned;
  size_t len;
} blacklist;

const blacklist none = {.banned = "", .len = 0};
const blacklist no_nulls = {.banned = "\x00", .len = 1};
const blacklist fgets_filter = {.banned = "\x00\n", .len = 2};
const blacklist no_control_codes = {.banned = "\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f", .len = 0x20};
const blacklist printable = {.banned = "\x00\x01\x02\x03\x04\x05\x06\x07\x08\t\n\x0b\x0c\r\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f\x7f\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8a\x8b\x8c\x8d\x8e\x8f\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9a\x9b\x9c\x9d\x9e\x9f\xa0\xa1\xa2\xa3\xa4\xa5\xa6\xa7\xa8\xa9\xaa\xab\xac\xad\xae\xaf\xb0\xb1\xb2\xb3\xb4\xb5\xb6\xb7\xb8\xb9\xba\xbb\xbc\xbd\xbe\xbf\xc0\xc1\xc2\xc3\xc4\xc5\xc6\xc7\xc8\xc9\xca\xcb\xcc\xcd\xce\xcf\xd0\xd1\xd2\xd3\xd4\xd5\xd6\xd7\xd8\xd9\xda\xdb\xdc\xdd\xde\xdf\xe0\xe1\xe2\xe3\xe4\xe5\xe6\xe7\xe8\xe9\xea\xeb\xec\xed\xee\xef\xf0\xf1\xf2\xf3\xf4\xf5\xf6\xf7\xf8\xf9\xfa\xfb\xfc\xfd\xfe\xff", .len = 161};

void print_blacklist(const blacklist *b) {
  printf("Banned: ");
  for (int i = 0; i < b->len; i++) {
    printf("\\x%02hhx ", b->banned[i]);
  }
  puts("\n");
}

void readline(char *buf, size_t max) {
  size_t i;
  for (i = 0; i < (max - 1); i++) {
    read(0, &buf[i], 1);
    if (buf[i] == '\n') {
      break;
    }
  }
  buf[i] = 0;
}

void readn(char *buf, size_t n) {
  size_t i = 0;
  while (i < n) {
    i += read(0, &buf[i], n - i);
  }
}

void get_and_run(const blacklist *b) {
  char num[5];

  puts("How many bytes long is your shellcode (send a newline after your number)? (max = 255)");
  readline(num, 5);

  unsigned char len = atoi(num) & 0xFF;

  void *loc = mmap(NULL, len, PROT_READ | PROT_WRITE | PROT_EXEC, MAP_PRIVATE | MAP_ANONYMOUS, 0, 0);
  printf("OK, reading %d bytes . . .\n", len);
  readn(loc, len);

  for (size_t i = 0; i < b->len; i++) {
    if (memchr(loc, b->banned[i], len)) {
      printf("Hey! You've got a \\x%02hhx in there!\n", b->banned[i]);
      exit(1);
    }
  }

  puts("Jumping! Good luck!");

  ((void (*)())loc)();

  puts("Uh-oh . . . you returned!");
  exit(1);
}

int main() {
  char choice[2];

  puts("Hi, which level do you want?");

  puts("0. No filter:");
  print_blacklist(&none);

  puts("1. No nulls:");
  print_blacklist(&no_nulls);

  puts("2. Fgets-style:");
  print_blacklist(&fgets_filter);

  puts("3. (Hard mode) No ascii control codes:");
  print_blacklist(&no_control_codes);

  puts("4. (Hard mode) Printables only:");
  print_blacklist(&printable);

  while (1) {
    printf("Give me a number: ");
    fflush(stdout);
    readline(choice, 3);
    switch(choice[0]) {
    case '0':
      get_and_run(&none);
    case '1':
      get_and_run(&no_nulls);
      break;
    case '2':
      get_and_run(&fgets_filter);
      break;
    case '3':
      get_and_run(&no_control_codes);
      break;
    case '4':
      get_and_run(&printable);
      break;
    default:
      break;
    }
  }
  return 0;
}
